local M = {}

local helper = require('scenario/scenariohelper')
local running = false
local scenario = nil
local redLap
local blueLap
local redCheck
local blueCheck
local lapCount


local function reset()
    running = false
end

local function onRaceStart()
	reset()
	running = true
	redLap = 1
	blueLap = 1
	redCheck = 0
	blueCheck = 0
	lapCount = 3
end


local function success(data)
	local result = {msg = 'The '..data..' car wins!'}
	scenario_scenarios.finish(result)
end

local function fail(reason)
  scenario_scenarios.finish({failed = reason})
  reset()
end

function onStartLine(data)
	local redCar = scenetree.findObject('RedCar')
	local blueCar = scenetree.findObject('BlueCar')
	if data.subjectName == redCar.name and redCheck == 2 then
		if redLap < lapCount then
			redCheck = 0
			redLap = redLap + 1
			helper.flashUiMessage('Red Lap!', 3)
		elseif redLap >= lapCount then
			success('red')
		end
	elseif data.subjectName == blueCar.name and blueCheck == 2 then
		if blueLap < lapCount then
			blueCheck = 0
			blueLap = blueLap + 1
			helper.flashUiMessage('Blue Lap!', 3)
		elseif blueLap >= lapCount then
			success('blue')
		end
	end
end

function onCorner(data)
	local redCar = scenetree.findObject('RedCar')
	local blueCar = scenetree.findObject('BlueCar')
	if data.subjectName == redCar.name and redCheck == 0 then
		redCheck = 1
	elseif data.subjectName == blueCar.name and blueCheck == 0 then
		blueCheck = 1
	end
end

function onChicane(data)
	local redCar = scenetree.findObject('RedCar')
	local blueCar = scenetree.findObject('BlueCar')
	if data.subjectName == redCar.name and redCheck == 1 then
		redCheck = 2
	elseif data.subjectName == blueCar.name and blueCheck == 1 then
		blueCheck = 2
	end
end

local function onRaceTick(raceTickTime)
	if not running then
        return true
    end
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick

return M